char version[31 + 1] = "5",
     release[31 + 1] = "11",
     revision[31 + 1] = "2",
     fname[31 + 1] = "GET_PATTS",
     productcode[31 + 1] = "GET_PATTS";

#include "imp2c.h"
#include "jb_patts.h"

int
main (int argc, char **argv)
{
  int files;
  int dfiles;
  int missing;
  int dmissing;
  int extra;
  int dextra;
  int zipped;
  int dzipped;
  int dummy;
  char jbname[255 + 1];
  char jobname[255 + 1];
  char line[255 + 1];
  char realname[255 + 1];
  char fromdirectory[255 + 1];
  static int wants[maxlayers+1];
  static char command[255 + 1];
  char tmp[256], *p;
  int i;

  int validlevels (char *levels)
  {
    int i, j, start = 0, end = 0, hadstart = false, char_;
    strcat (levels, ",");
    for (i = 1; i <= strlen (levels); i += 1)
      {
	char_ = levels[(i) - 1];
	if ('0' <= char_ && char_ <='9')
	  {
	    if (hadstart == false)
	      {
		start = start * 10 + char_ - '0';
	      }
	    else
	      {
		end = end * 10 + char_ - '0';
	      }
	  }
	else if (char_ == ',')
	  {
	    if (hadstart == false)
	      {
		if (0 <= start && start <= maxlayers)
		  wants[start] = true;
	      }
	    else
	      {
		if ((0 <= start) && (start <= maxlayers) && (0 <= end)
		    && (end <= maxlayers))
		  {
		    for (j = start; j <= end; j += 1)
		      {
			wants[j] = true;
		      }
		  }
		else
		  {
		    return (0 != 0);
		  }
	      }
	    start = 0;
	    end = 0;
	    hadstart = false;
	  }
	else if (char_ == '-')
	  {
	    if (start != 0)
	      hadstart = true;
	  }
	else
	  {
	    if (char_ > ' ')
	      return (0 != 0);
	  }
      }
    return (0 == 0);
  }

  imp_init(argc, argv);
  for (i = 0; i <= maxlayers; i++) wants[i] = false;
  if (qualifierpresent ("IDENTIFY"))
    {
      printidentification ();
      if (!(qualifierpresent ("FILES")))
	exit(1);
    }
  strcpy(jbname, qualifiers ("FILES"));
  if ((strcmp (jbname, "") == 0))
    {
      prompt ("Job Deck Name: ");
      readline (jbname, sizeof(jbname));
      while (nextsymbol() != nl)
	skipsymbol ();
      skipsymbol ();
    }
  if (!(strchr (jbname, '.')))
    strcat (jbname, ".jb");
  if (!openinput (1, jbname)) fatalerror ("Cannot open input file %s", jbname);
  selectinput (1);
  strcpy(line, qualifiers ("LEVELS"));
  if ((strcmp (line, "") == 0))
    {
    redolevels:
      selectinput (0);
      prompt ("JB Levels to be used, 0 for all: ");
      readline (line, sizeof(line));
    }
  if (!(validlevels (line)))
    goto redolevels;
  strcpy(fromdirectory, qualifiers ("FROM"));
  if (strcmp (fromdirectory, ""))
    {
      if (qualifierpresent ("RENAME"))
	{
	  if (strstr (fromdirectory, ("STD_DIR:"))
	      || strstr (fromdirectory, ("stdjob/")))
	    {
	      fatalerror("RENAME qualifier cannot be used with STD_DIR files");
	    }
	  setfromoption (renamemode, fromdirectory);
	}
      else
	{
	  setfromoption (copymode, fromdirectory);
	}
    }
  else if (qualifierpresent ("NONE"))
    {
      setfromoption (nofrommode, "");
    }
  zipped = false;
  parsejobdeck (wants, 1);
  closeinput ();
  if (qualifierpresent ("ALL"))
    {
      scanjobdeckpatterns (getallpatterns, files, missing, extra, zipped);
    }
  else if (!(qualifierpresent ("NONE")))
    {
      scanjobdeckpatterns (getcustomerpatterns, files, missing, extra,
			   zipped);
    }
  scanjobdeckpatterns (checkmissinglist, files, missing, extra, zipped);
  if (qualifierpresent ("DEBUG"))
    {
      selectoutput (0);
      scanjobdeckpatterns (dumpdatastructure, dfiles, dmissing, dextra,
			   dzipped);
      selectoutput (1);
    }
  if (missing != 0)
    {
      scanjobdeckpatterns (outputmissinglist, files, missing, dummy, dummy);
    }
  if (extra != 0)
    {
      scanjobdeckpatterns (outputextralist, files, dummy, extra, dummy);
    }
  selectoutput (0);
  fprintf (outfile, "%s uses %0d patterns, %0d missing, with %0d extra file",
	       jbname, files - extra, missing, extra);

  if (extra != 1)
    fprintf (outfile, "s");
  fprintf (outfile, "\n");
  if (missing != 0)
    {
      fatalerror ("Please correct the problem with the missing patterns");
    }
  if (extra != 0 && (!qualifierpresent ("ALLOW_EXTRA")))
    {
      selectinput (0);
      prompt ("Please enter your name to confirm extra patterns are OK: ");
      readline (realname, sizeof(realname));
      imp_toupper (realname);
      if ((p=strchr(jbname, ']')) != NULL)
	{
          *p = '\0';
	  strcat (jbname, "]");
	}
      else if ((p=strchr(jbname, ':')) != NULL)
	{
          *p = '\0';
	  strcat (jbname, ":");
	}
      else
	{
	  strcpy (jbname, "");
	}
      sprintf(tmp, "%sget_patts.log", jbname);
      openoutput (1, tmp);
      selectoutput (1);
      fprintf (outfile, "GET_PATTS version %s.%s", version, release);
      if (strcmp (revision, "0"))
	{
	  fprintf (outfile, ".%s", revision);
	}
      fprintf (outfile, " was run by %s at %s on %s\n", realname, imp_time(), imp_date());
      scanjobdeckpatterns (outputextralist, files, dummy, extra, zipped);
      fprintf (outfile, "\n\n");
      closeoutput ();
    }
  if (zipped == true)
    {
      selectoutput (0);
      if (strstr (translate ("SYS$SYSROOT"), ("DRA"))
	  || strstr (translate ("SYS$SYSROOT"), ("DKA")))
	{
	  fprintf (outfile, "Now decompressing the %s files\n", zippedextension);
	  sprintf(command, "GUNZIP *.*%s", zippedextension);
	  spawncommand (command);
	}
      else
	{
	  fprintf (outfile, "Please use an Alpha system to decompress the -GZ files\n");
	}
    }
  exit(0);
  return(0);
}
