char productcode[31 + 1] = "PLC",
     fname[31 + 1] = "PLC",
     version[31 + 1] = "2",
     release[31 + 1] = "11",
     revision[31 + 1] = "5";

#include "imp2c.h"

const int summary = 0;
const int detail = 1;

void
printlimits (char *s, char *file, int mode)
{
  char a[255 + 1];
  char b[255 + 1];
  char lxs[255 + 1];
  char uxs[255 + 1];
  char lys[255 + 1];
  char uys[255 + 1];
  char cxs[255 + 1];
  char cys[255 + 1];
  float cx, cy;
  char *p; // gt temp pointer
//  if (setjmp ())
//    {
//      newline ();
//      return;
//    }
  if ((strcmp (s, "") == 0) && (strcmp (file, "") == 0))
    return;
  if ((strcmp (s, "") == 0))
    {
//      %if File -> (":").File %start; %finish
      if ((p=strchr(file, ':')) != NULL)
	{
          memmove(file, p+1, strlen(p+1)+1);
	}
//      %if File -> ("]").File %start; %finish
      if ((p=strchr(file, ']')) != NULL)
	{
          memmove(file, p+1, strlen(p+1)+1);
	}
//      %if File -> File.(";") %start; %finish
      if ((p=strchr(file, ';')) != NULL)
        {
          *p = '\0';
	}
      if (strlen (file) == 12)
	{
	  fprintf (outfile, " from MEBES file");
	}
      else
	{
	  fprintf (outfile, " default from input file");
	}
      fprintf (outfile, "\n");
      return;
    }
  else if (strstr (s, ("EXT")))
    {
      fprintf (outfile, " extents from input file\n");
      return;
    }
  imp_toupper (s);

//   S = A.B %while S -> A.("(INPUT ").B
  while (sscanf(s, "%s(INPUT %s", a, b))
    sprintf(s, "%s%s", a, b);

//   S = A.B %while S -> A.(")").B
  while (sscanf(s, "%s)%s", a, b))
    sprintf(s, "%s%s", a, b);
//   S = A." ".B %while S -> A.("  ").B
  while (sscanf(s, "%s  %s", a, b))
    sprintf(s, "%s %s", a, b);
//   S = A.",".B %while S -> A.(" ").B
  while (sscanf(s, "%s  %s", a, b))
    sprintf(s, "%s,%s", a, b);
//   %if S -> LXS.(",").A %start; %finish
  (void)sscanf(s, "%s,%s", lxs, b);
//   %if A -> LYS.(",").A %start; %finish
  (void)sscanf(a, "%s,%s", lys, a); // IS THIS SAFE?  RECODE AS memmove???
//   %if A -> UXS.(",").UYS %start; %finish
  (void)sscanf(a, "%s,%s", uxs, uys);

  if (mode == detail)
    {
      spaces (10 - strlen (lxs));
    }
  else
    {
      space ();
    }
  fprintf (outfile, "%s,%s", lxs, lys);
  if (mode == detail)
    {
      spaces (20 - strlen (lys) - strlen (uxs));
    }
  else
    {
      fprintf (outfile, " to ");
    }
  fprintf (outfile, "%s,%s", uxs, uys);
  cx = ((float) ((stor (uxs) - stor (lxs))) / (float) (2 + stor (lxs)));
  cy = ((float) ((stor (uys) - stor (lys))) / (float) (2 + stor (lys)));
  sprintf(cxs, "%0.5f", cx);
  while (cxs[(strlen (cxs)) - 1] == '0')
    cxs[strlen (cxs) - 1] = '\0';
  if (cxs[(strlen (cxs)) - 1] == '.')
    cxs[strlen (cxs) - 1] = '\0';
  sprintf(cys, "%0.5f", cy);
  while (cys[(strlen (cys)) - 1] == '0')
    cys[strlen (cys) - 1] = '\0';
  if (cys[(strlen (cys)) - 1] == '.')
    cys[strlen (cys) - 1] = '\0';
  if (mode == detail)
    {
      spaces (20 - strlen (uys) - strlen (cxs));
    }
  else
    {
      fprintf (outfile, " centre ");
    }
  fprintf (outfile, "%s,%s\n", cxs, cys);
}

int
main (int argc, char **argv)
{
#define maxlayer 1000
#define true 1
#define false 0
  const int primary = 0, secondary = 1, switch_ = 1;
  static char gash[255 + 1];
  char lastdirectory[255 + 1];
  char thisdirectory[255 + 1];
  char code[255 + 1];
  char param[255 + 1];
  char file[127 + 1], user[127 + 1] = "";
  const int eof = 0x1827A, nsc = 0x10001, nmf = 0x182CA, topbit =
    0x10000000;
  char defnam[15 + 1];
  int status;
  int count;
  int files;
  int total;
  int source;
  int hadfunction = false;
  char junk[255 + 1];
  char es[255 + 1];
  char rs[255 + 1];
  char cincnames[maxlayer+1][31+1];
#define cincnames(n) cincnames[(n)]
  char functions[maxlayer+1][63+1];
#define functions(n) functions[(n)]
  static char resolutions[maxlayer - 1 + 1 /* hack for now */ ][31+1] = {
"?", "?", "?", "?", "?", "?", "?", "?",
"?", "?", "?", "?", "?", "?", "?", "?",
"?", "?", "?", "?", "?", "?", "?", "?",
"?", "?", "?", "?", "?", "?", "?", "?",
};
#define resolutions(n) resolutions[(n)]
  static char reverses[maxlayer+1][31+1];
#define reverses(n) reverses[(n)]
  char grows[maxlayer+1][31+1];
#define grows(n) grows[(n)]
  char oselects[maxlayer+1][127+1];
#define oselects(n) oselects[(n)]
  char pselects[maxlayer+1][127+1];
#define pselects(n) pselects[(n)]
  char pinputs[maxlayer+1][63+1];
#define pinputs(n) pinputs[(n)]
  char plimits[maxlayer+1][127+1];
#define plimits(n) plimits[(n)]
  char psizings[maxlayer+1][31+1];
#define psizings(n) psizings[(n)]
  char pscalings[maxlayer+1][31+1];
#define pscalings(n) pscalings[(n)]
  char porients[maxlayer+1][31+1];
#define porients(n) porients[(n)]
  char players[maxlayer+1][63+1];
#define players(n) players[(n)]
  char pstructures[maxlayer+1][63+1];
#define pstructures(n) pstructures[(n)]
  char sselects[maxlayer+1][127+1];
#define sselects(n) sselects[(n)]
  char sinputs[maxlayer+1][63+1];
#define sinputs(n) sinputs[(n)]
  char slimits[maxlayer+1][127+1];
#define slimits(n) slimits[(n)]
  char ssizings[maxlayer+1][31+1];
#define ssizings(n) ssizings[(n)]
  char sscalings[maxlayer+1][31+1];
#define sscalings(n) sscalings[(n)]
  char sorients[maxlayer+1][31+1];
#define sorients(n) sorients[(n)]
  char slayers[maxlayer+1][63+1];
#define slayers(n) slayers[(n)]
  char sstructures[maxlayer+1][63+1];
#define sstructures(n) sstructures[(n)]

  void checkfile ()
  {
    char line[255 + 1];
    char uline[255 + 1];
    char cincname[255 + 1];
    char *p; // gt temp
//    if (setjmp ())
//      {
//	return;
//      }

      if (!openinput (1, rs))
	{
	  warningmessage ("Warning: Unable to open .cinc file %s", rs);
          return;
	}
      selectinput (1);

//      %if RS -> ("]").Cinc name %start
    if ((p=strchr(rs, ']')) != NULL)
      {
        strcpy(cincname, p+1);
      }
//      %else %if RS -> ("/").Cinc name
    else if ((p=strchr(rs, '/')) != NULL)
      {
        strcpy(cincname, p+1);
      }
    else
      {
	strcpy(cincname, rs);
      }
//      %return %unless Cinc name -> Cinc name.(".CINC") %or -
//                      Cinc name -> Cinc name.(".cinc")
    if (((p = strstr(cincname, ".CINC")) == NULL) &&
        ((p = strstr(cincname, ".cinc")) == NULL)) {
      return;
    } else *p = '\0';
    {
// an error in the code below triggers the code above!
      count += 1;
      strcpy(cincnames[count], cincname);
      strcpy (players[count], "");
      strcpy (psizings[count], "0");
      strcpy (porients[count], "0");
      strcpy (pscalings[count], "1");
      strcpy (players[count], "");
      strcpy (pinputs[count], "");
      strcpy (plimits[count], "");
      strcpy (pstructures[count], "");
      strcpy (ssizings[count], "0");
      strcpy (sorients[count], "0");
      strcpy (sscalings[count], "1");
      strcpy (slayers[count], "");
      strcpy (sinputs[count], "");
      strcpy (sstructures[count], "");
      strcpy (slimits[count], "");
      strcpy (functions[count], "");
      strcpy (grows[count], "0");
      strcpy (oselects[count], "no");
      strcpy (pselects[count], "no");
      strcpy (sselects[count], "no");
      strcpy (reverses[count], "no");
      source = primary;
      for (;;)
	{
	  if (!readline (line, sizeof(line))) {
	  closeinput ();
	  if (strcmp (grows (count), "0"))
	    {
	      if (strcmp (psizings (count), "0"))
		{
		  if ((stor (grows (count)) > 0
		      && stor (psizings (count)) > 0)
		      || (stor (grows (count)) < 0
		      && stor (psizings (count)) < 0))
		    {
		      if (!((strcmp (functions (count), "XOR") == 0)))
			{
			  selectoutput (0);
			  fprintf (outfile, "File %s has both GROW and Primary SIZE in same direction\n", cincname);
			  if ((strcmp (user, "") == 0))
			    {
			      selectinput (0);
			      prompt
				("Enter your initials to confirm this is OK: ");
			      readline (user, sizeof(user));
			      imp_toupper (user);
			    }
			}
		    }
		}
	      if (strcmp (ssizings (count), "0"))
		{
		  if ((stor (grows (count)) > 0
		      && stor (ssizings (count)) > 0)
		      || (stor (grows (count)) < 0
		      && stor (ssizings (count)) < 0))
		    {
		      selectoutput (0);
		      fprintf (outfile, "File %s has both GROW and Secondary SIZE in same direction\n", cincname);
		      if (strcmp (user, ""))
			{
			  selectinput (0);
			  prompt
			    ("Enter your initials to confirm this is OK: ");
			  readline (user, sizeof(user));
			  imp_toupper (user);
			}
		    }
		}
	    }
	  return;
	}




	  if (strlen (line) <= 3)
	    continue;
	  if ((strcmp (substring (line, 1, 3), "! #") == 0))
	    {
	      count -= 1;
	      return;
	    }
	  strcpy(uline, line);
	  imp_toupper (uline);
	  strcpy(code, substring (uline, 1, 3));
//            %if Line -> (" ").Param %start; %finish
	  if ((p=strchr(line, ' ')) != NULL)
	    {
              strcpy(param, line+1);
	    }
	  if ((strcmp (code, "SWI") == 0))
	    {
	      source ^= switch_;
	    }
	  else if ((strcmp (code, "INP") == 0))
	    {
	      if (source == primary)
		{
		  strcpy (gash, "");
//                  %if Param -> (":").gash  %start
		  if ((p=strchr(param, ':')) != NULL)
		    {
                      strcpy(gash, p+1);
		    }
//                  %else %if Param -> ("]").gash
		  else if ((p=strchr(param, ']')) != NULL)
		    {
                      strcpy(gash, p+1);
		    }
//                  %else %if Param -> ("/").gash
		  else if ((p=strchr(param, '/')) != NULL)
		    {
                      strcpy(gash, p+1);
		    }
		  else
		    {
		      strcpy(gash, param);
		    }
		  strcpy(pinputs[count], gash);
		}
	      else
		{
//                  %if Param -> (":").gash  %start
		  if ((p=strchr(param, ':')) != NULL)
		    {
                      strcpy(gash, p+1);
		    }
//                  %else %if Line -> ("]").gash
		  else if ((p=strchr(line, ']')) != NULL)
		    {
                      strcpy(gash, p+1);
		    }
//                  %else %if Line -> ("/").gash
		  else if ((p=strchr(line, '/')) != NULL)
		    {
                      strcpy(gash, p+1);
		    }
		  else
		    {
		      strcpy(gash, param);
		    }
		  strcpy(sinputs[count], gash);
		}
	    }
	  else if ((strcmp (code, "LIM") == 0))
	    {
	      if (source == primary)
		{
		  strcpy(plimits[count], param);
		}
	      else
		{
		  strcpy(slimits[count], param);
		}
	    }
	  else if ((strcmp (code, "FUN") == 0))
	    {
	      strcpy(functions[count], param);
	      hadfunction = true;
	    }
	  else if ((strcmp (code, "RES") == 0))
	    {
	      strcpy(resolutions[count], param);
	    }
	  else if ((strcmp (code, "GRO") == 0))
	    {
	      strcpy(grows[count], param);
	    }
	  else if ((strcmp (code, "SIZ") == 0))
	    {
	      if (source == primary)
		{
		  strcpy(psizings[count], param);
		}
	      else
		{
		  strcpy(ssizings[count], param);
		}
	    }
	  else if ((strcmp (code, "SCA") == 0))
	    {
	      if (source == primary)
		{
		  strcpy(pscalings[count], param);
		}
	      else
		{
		  strcpy(sscalings[count], param);
		}
	    }
	  else if ((strcmp (code, "ORI") == 0))
	    {
	      if (source == primary)
		{
		  strcpy(porients[count], param);
		}
	      else
		{
		  strcpy(sorients[count], param);
		}
	    }
	  else if ((strcmp (code, "REV") == 0))
	    {
	      strcpy(reverses[count], param);
	    }
	  else if ((strcmp (code, "SEL") == 0))
	    {
	      if (strstr (uline, (" OUT")))
		{
		  strcpy (oselects[count], "YES");
		}
	      else if (source == primary)
		{
		  strcpy (pselects[count], "YES");
		}
	      else
		{
		  strcpy (sselects[count], "YES");
		}
	    }
	  else if ((strcmp (code, "LAY") == 0))
	    {
	      if (source == primary)
		{
		  strcpy(players[count], param);
		}
	      else
		{
		  strcpy(slayers[count], param);
		}
	    }
	  else if ((strcmp (code, "STR") == 0))
	    {
	      if (source == primary)
		{
		  strcpy(pstructures[count], param);
		}
	      else
		{
		  strcpy(sstructures[count], param);
		}
	    }
	}
    }
  }

  void outputinformation ()
  {
    int i;
    int different;
    if (strcmp (user, ""))
      {
	fprintf (outfile, "User %s confirmed that same sign sizing was OK\n", user);
      }
    fprintf (outfile, "\n");
    if (count > 1)
      {
	different = false;
	for (i = 2; i <= count; i += 1)
	  {
	    if (pinputs (i) != pinputs (1)
		|| pstructures (i) != pstructures (1))
	      different = true;
	  }
      }
    else
      {
	different = true;
      }
    if (different == false)
      {
	fprintf (outfile, "All primary   files input from \"%s\"", pinputs (1)); // filtering lost
	if (strcmp (pstructures (1), ""))
	  {
	    fprintf (outfile, " with structure \"%s\"", pstructures (1));
	  }
        fprintf (outfile, "\n");
      }
    else
      {
	fprintf (outfile, "Filename       Primary Input                  Structure\n");
	for (i = 1; i <= count; i += 1)
	  {
	    fprintf (outfile, cincnames (i));  // something like %15s???
	    spaces (15 - strlen (cincnames (i)));
	    fprintf (outfile, pinputs (i));
	    space ();
	    spaces (30 - strlen (pinputs (i)));
	    fprintf (outfile, "%s\n", pstructures (i));
	  }
      }
    if (hadfunction == true)
      {
        fprintf (outfile, "\n");
	if (count > 1)
	  {
	    different = false;
	    for (i = 2; i <= count; i += 1)
	      {
		if (sinputs (i) != sinputs (1)
		    || sstructures (i) != sstructures (1))
		  different = true;
	      }
	  }
	else
	  {
	    different = true;
	  }
	if (different == false)
	  {
	    fprintf (outfile, "All secondary files input from \"%s\"", sinputs (1));
	    if (strcmp (sstructures (1), ""))
	      {
		fprintf (outfile, " with structure \"%s\"", sstructures (1));
	      }
            fprintf (outfile, "\n");
	  }
	else
	  {
	    fprintf (outfile, "Filename       Secondary Input                Structure\n");
	    for (i = 1; i <= count; i += 1)
	      {
		if ((strcmp (functions (i), "") == 0))
		  continue;
		fprintf (outfile, cincnames (i));
		spaces (15 - strlen (cincnames (i)));
		fprintf (outfile, "%s ", sinputs (i));
		spaces (30 - strlen (sinputs (i)));
		fprintf (outfile, "%s\n", sstructures (i));
	      }
	  }
      }
    fprintf (outfile, "\n");
    if (count > 1)
      {
	different = false;
	for (i = 2; i <= count; i += 1)
	  {
	    if (plimits (i) != plimits (1))
	      different = true;
	  }
      }
    else
      {
	different = true;
      }
    if (different == false)
      {
	fprintf (outfile, "All primary   files have LIMITS ");
	printlimits (plimits (1), pinputs (1), summary);
      }
    else
      {
	fprintf (outfile, "Filename       Primary Limits   LX,LY       UX,UY                CX,CY\n");
	for (i = 1; i <= count; i += 1)
	  {
	    fprintf (outfile, "%s", cincnames (i));
	    spaces (15 - strlen (cincnames (i)));
	    printlimits (plimits (i), pinputs (i), detail);
	  }
      }
    if (hadfunction == true)
      {
        fprintf (outfile, "\n");
	if (count > 1)
	  {
	    different = false;
	    for (i = 2; i <= count; i += 1)
	      {
		if (slimits (i) != slimits (1) || sinputs (i) != sinputs (1))
		  different = true;
	      }
	  }
	else
	  {
	    different = true;
	  }
	if (different == false)
	  {
	    fprintf (outfile, "All secondary files have LIMITS ");
	    printlimits (slimits (1), sinputs (1), summary);
	  }
	else
	  {
	    fprintf (outfile, "Filename       Secondary Limits   LX,LY     UX,UY                CX,CY\n");
	    for (i = 1; i <= count; i += 1)
	      {
		if ((strcmp (slimits (i), "") == 0)
		    && (strcmp (sinputs (i), "") == 0))
		  continue;
		fprintf (outfile, "%s", cincnames (i));
		spaces (15 - strlen (cincnames (i)));
		printlimits (slimits (i), sinputs (i), detail);
	      }
	  }
      }
    fprintf (outfile, "\nFilename       Layers         Resol'n  Grow Sizing Scaling Orient Reverse Select\n");
    for (i = 1; i <= count; i += 1)
      {
	fprintf (outfile, "%s", cincnames (i));
	spaces (15 - strlen (cincnames (i)));
	if ((strcmp (players (i), "") == 0))
	  strcpy (players[i], "CFLT");
	fprintf (outfile, "%s", players (i));
	space ();
	spaces (14 - strlen (players (i)));
	strcpy(junk, resolutions (i));
	if (strchr (junk, '.'))
	  {
	    while (junk[(strlen (junk)) - 1] == '0')
	      junk[strlen (junk) - 1] = '\0';
	    if (junk[(strlen (junk)) - 1] == '.')
	      strcat (junk, "0");
	  }
	fprintf (outfile, "%s", junk);
	space ();
	spaces (12 - strlen (junk) - strlen (grows (i)));
	fprintf (outfile, "%s", grows (i));
	space ();
	strcpy(junk, psizings (i));
	if (strchr (junk, '.'))
	  {
	    while (junk[(strlen (junk)) - 1] == '0')
	      junk[strlen (junk) - 1] = '\0';
	    if (junk[(strlen (junk)) - 1] == '.')
	      strcat (junk, "0");
	  }
	spaces (6 - strlen (junk));
	fprintf (outfile, "%s", junk);
	space ();
	spaces (7 - strlen (pscalings (i)));
	fprintf (outfile, "%s", pscalings (i));
	space ();
	spaces (6 - strlen (porients (i)));
	fprintf (outfile, "%s", porients (i));
	spaces (4);
	fprintf (outfile, "%s", reverses (i));
	space ();
	spaces (6 - strlen (reverses (i)));
	fprintf (outfile, "%s\n", pselects (i));
	if (strcmp (functions (i), ""))
	  {
	    fprintf (outfile, "   fun ");
	    fprintf (outfile, "%s", functions (i));
	    spaces (8 - strlen (functions (i)));
	    if ((strcmp (slayers (i), "") == 0))
	      strcpy (slayers[i], "CFLT");
	    fprintf (outfile, "%s", slayers (i));
	    space ();
	    strcpy(junk, ssizings (i));
	    if (strchr (junk, '.'))
	      {
		while (junk[(strlen (junk)) - 1] == '0')
		  junk[strlen (junk) - 1] = '\0';
		if (junk[(strlen (junk)) - 1] == '.')
		  strcat (junk, "0");
	      }
	    spaces (34 - strlen (slayers (i)) - strlen (junk));
	    fprintf (outfile, "%s", junk);
	    space ();
	    spaces (7 - strlen (sscalings (i)));
	    fprintf (outfile, "%s", sscalings (i));
	    space ();
	    spaces (6 - strlen (sorients (i)));
	    fprintf (outfile, "%s", sorients (i));
	    spaces (11);
	    fprintf (outfile, "%s\n", sselects (i));
	  }
      }
  }
// START OF MAIN PROGRAM
  if (qualifierpresent ("IDENTIFY"))
    {
      printidentification ();
      if (!(qualifierpresent ("FILE")))
	exit(1);
    }
  count = 0;
  files = 0;
  for (;;)
    {
      strcpy(rs, qualifiers ("FILES"));
      if ((strcmp (rs, "") == 0))
	{
	  if (files == 0)
	    {
	      spawncommand ("plc *.cinc");
	      exit (0);
	    }
	  break;
	}
      if (strstr (rs, ("CATS_START.CINC"))
	  || strstr (rs, ("cats_start.cinc")))
	continue;
      files += 1;
      checkfile ();
    }
  outputinformation ();
  if (!openoutput (3, "plc.log"))
    {
      fatalerror ("Unable to open file PLC.LOG in the current directory");
    }
  selectoutput (3);
  outputinformation ();
  closeoutput ();
  exit(0);
  return(0);
}
