char version[31 + 1] = "1",
  release[31 + 1] = "9",
  revision[31 + 1] = "2",
  fname[31 + 1] = "SOP_IMPORT", productcode[31 + 1] = "SOP_IMPORT";
#include "imp2c.h"
#include <time.h>

int
main (int argc, char **argv)
{
#define true 1
#define false 0
#define maxlayers 100
#ifdef unix
#undef unix
#endif
  int unix = true;
  int i, s, max = 0;
  int numrets = 0, nummast = 0, numsubs = 0, numcopy = 0;
  int numplot = 0, numpels = 0;
  char custcode[3 + 1] = "???";
  char file[255 + 1];
  char newfile[255 + 1];
  char s1[255 + 1];
//  char s2[255 + 1];
//  char s3[255 + 1];
  char temp[255 + 1];
  char description[255 + 1];
  char sopcode[255 + 1];
  char invoice[255 + 1];
  char device[255 + 1],
    layer[255 + 1],
    cmcnum[255 + 1],
    ponumber[255 + 1] = "",
    site[255 + 1] = "", size[255 + 1], process[255 + 1];
  char comments[255 + 1], quote[255 + 1] = "";
  static int quantities[maxlayers + 1];
#define quantities(n) quantities[(n)]
  static int mc[maxlayers + 1];
#define mc(n) mc[(n)]
  static char lines[maxlayers + 1][255 + 1];
#define lines(n) lines[(n)]
  static char grades[maxlayers + 1][7 + 1];
#define grades(n) grades[(n)]
  static char tols[maxlayers + 1][7 + 1];
#define tols(n) tols[(n)]

  void reportcreationof (char *file)
  {
    selectoutput (0);
    fprintf (outfile, "File %s created for import to SOP system\n", file);
  }
  void readitem (char *item)
  {
    *item = '\0';
    for (;;)
      {
	readsymbol (&s);	// yuck.  global int s.
	if (s == tab)
	  break;
	*item++ = s;
      }
    *item = '\0';
  }
  char *numdate (void)
  {
    char result[7];
    struct tm *tm;
    time_t timep;
    time (&timep);
    tm = localtime (&timep);
    // this can be replaced entirely by a C library call to strftime
    strftime (result, 7, "%d%m%y", tm);
    return (strdup (result));
  }

  void outputheader (char *accountcode, int max)
  {
    fprintf (outfile, "%s\t", accountcode);
    fprintf (outfile, "Order\t");
    fprintf (outfile, "%s\t\t%0d\t", numdate (), max);
    fprintf (outfile, "%s\t", site);
    fprintf (outfile, "%s\t", ponumber);
    fprintf (outfile, "tba\t");
    fprintf (outfile, "%s\t\r", quote);
  }

  void outputlineentry (int quantity, char *device, char *layer, char *code,
			char *description, int numrets, int nummast,
			int numsubs, int numcopy, int numplot, int numpels,
			int wip, int deliver)
  {
    fprintf (outfile, "\t\t%0d\t%s\t%s\t%s\t", quantity, device, layer, code);
    fprintf (outfile, "%s\t\t\t", description);
    fprintf (outfile, "tba\t%0d\t%0d\t%0d\t%0d\t%0d\t",
	     numrets, nummast, numsubs, numcopy, numplot);
    fprintf (outfile, "%0d\t%0d\t%0d\t\t\r", numpels, wip, deliver);
  }
  void parseamsorder ()
  {
    int num;
    char line[255 + 1];
    char rest[255 + 1];
    char lev[255 + 1];
    char *p;
    readline (line, sizeof (line));
    if (!(strstr (line, ("Austriamicrosystems"))))
      {
	fatalerror ("This is not an Austriamicrosystems order");
      }
    do
      {
	readline (line, sizeof (line));
      }
    while (!((p = strstr (line, "num_reticles:=:")) != NULL));
    safe_strcpy (rest, p + strlen ("num_reticles:=:"));
    max = atoi (rest);
    do
      {
	readline (line, sizeof (line));
      }
    while (!((p = strstr (line, "dev_name:=:")) != NULL));
    safe_strcpy (rest, p + strlen ("dev_name:=:"));

    safe_strcpy (device, rest);
    for (;;)
      {
	char tmp[256];
	readline (line, sizeof (line));
	if ((p = strstr (line, "cr_pel_attach_r")) != NULL)
	  {
	    safe_strcpy (rest, p + strlen ("cr_pel_attach_r"));
	    if ((p = strstr (rest, ":=:")) != NULL)
	      {
		safe_strncpy (lev, rest, p - rest);
		safe_strcpy (rest, p + strlen (":=:"));	// todo: safer copy
	      }
	    safe_sprintf (tmp, "%s-", device);
	    if ((p = strstr (rest, tmp)) != NULL)
	      {
		safe_strcpy (rest, p + strlen (tmp));
	      }
	    imp_toupper (rest);
	    if ((strcmp (rest, "Y") == 0) || (strcmp (rest, "YES") == 0))
	      num = 1;
	    else
	      num = 0;
	    quantities[atoi (lev) + 1] = num;
	  }
	else if ((p = strstr (line, "cd_tolerance_r")) != NULL)
	  {
	    safe_strcpy (rest, p + strlen ("cd_tolerance_r"));
	    if ((p = strstr (rest, ":=:")) != NULL)
	      {
		safe_strncpy (lev, rest, p - rest);
		safe_strcpy (rest, p + strlen (":=:"));	// todo: safer copy
	      }
	    num = atoi (lev) + 1;
	    if ((strcmp (rest, "0.3") == 0))
	      {
		safe_strcpy (rest, "A");
	      }
	    else if ((strcmp (rest, "0.2") == 0))
	      {
		safe_strcpy (rest, "B");
	      }
	    else if ((strcmp (rest, "0.15") == 0))
	      {
		safe_strcpy (rest, "C");
	      }
	    else if ((strcmp (rest, "0.1") == 0))
	      {
		safe_strcpy (rest, "D");
	      }
	    else if ((strcmp (rest, "0.07") == 0))
	      {
		safe_strcpy (rest, "E");
	      }
	    else
	      {
		fatalerror ("Unknown AMS tolerance %s", rest);
	      }
	    safe_strcpy (grades[num], rest);
	  }
	else if ((p = strstr (line, "mask_titles_r")) != NULL)
	  {
	    safe_strcpy (rest, p + strlen ("mask_titles_r"));
	    if ((p = strstr (rest, ":=:")) != NULL)
	      {
		safe_strncpy (lev, rest, p - rest);
		safe_strcpy (rest, p + strlen (":=:"));	// todo: safer copy
	      }
	    safe_sprintf (tmp, "%s-", device);
	    if ((p = strstr (rest, tmp)) != NULL)
	      {
		safe_strcpy (rest, p + strlen (tmp));
	      }
	    num = atoi (lev) + 1;
	    safe_strcpy (lines[num], rest);
	  }
	if ((strcmp (line, "%END_P4!1!%") == 0))
	  break;
      }
  }

  void outputamsdata (void)
  {
    int i;
    char grade[255 + 1] = "?",
//         rest[255 + 1],
      pel[255 + 1];

    char *amsscodes (int pel, char *grade)
    {
      if (pel == 0)
	{
	  if ((strcmp (grade, "A") == 0) || (strcmp (grade, "B") == 0))
	    return (strdup ("2130\tA1"));
	  if ((strcmp (grade, "C") == 0) || (strcmp (grade, "D") == 0))
	    return (strdup ("2130\tA2"));
	  if ((strcmp (grade, "E") == 0))
	    return (strdup ("8130\tA1"));
	}
      else
	{
	  if ((strcmp (grade, "A") == 0) || (strcmp (grade, "B") == 0))
	    return (strdup ("2131\tA1"));
	  if ((strcmp (grade, "C") == 0) || (strcmp (grade, "D") == 0))
	    return (strdup ("2131\tA2"));
	  if ((strcmp (grade, "E") == 0))
	    return (strdup ("8131\tA1"));
	}
      fatalerror ("Unknown AMS grade - \"%s\"", grade);
      return (strdup (""));
    }

    safe_strcpy (quote, "16092A");
    outputheader ("018", max);
    for (i = 1; i <= max; i += 1)
      {
	safe_strcpy (layer, lines (i));
	safe_strcpy (grade, grades (i));
	numpels = quantities (i);
	safe_strcpy (sopcode, amsscodes (numpels, grade));
	numrets = 1;
	if (numpels == 0)
	  {
	    safe_strcpy (pel, "No ");
	  }
	else
	  {
	    safe_strcpy (pel, "");
	  }
	safe_sprintf (description, "6\" Reticle + %sPellicle Grade %s", pel,
		 grade);
	outputlineentry (1, device, layer, sopcode, description, numrets,
			 nummast, numsubs, numcopy, numplot, numpels, 'Y',
			 'Y');
      }
    fprintf (outfile, "\n");
  }
  void parseanaorder ()
  {
    char laystr[255 + 1];
    char temp[255 + 1];
    int s;
    char *p;			//gt
    do
      {
	readline (ponumber, sizeof (ponumber));
      }
    while ((p = strstr (ponumber, "Purchase Order Number:")) == NULL);
    safe_strcpy (ponumber, p + strlen ("Purchase Order Number:"));
    while (ponumber[(strlen (ponumber)) - 1] == ' '
	   || ponumber[(strlen (ponumber)) - 1] == tab)
      ponumber[strlen (ponumber) - 1] = '\0';
    while (strcmp (ponumber, "") && (ponumber[(1) - 1] == ' '
				     || ponumber[(1) - 1] == tab))
      safe_strcpy (ponumber, substring (ponumber, 2, strlen (ponumber)));
    do
      {
	read_string (device);
      }
    while (!((strcmp (device, "Device:") == 0)));
    read_string (device);
    do
      {
	read_string (process);
      }
    while (!((strcmp (process, "Process:") == 0)));
    read_string (process);
    do
      {
	readsymbol (&s);
      }
    while (!(s == ':'));
    read_int (&max);
    do
      {
	readsymbol (&s);
      }
    while (!(s == nl));
    do
      {
	readsymbol (&s);
      }
    while (!(s == ':'));
    while (nextsymbol () <= ' ')
      skipsymbol ();
    if (nextsymbol () == '5')
      {
	safe_strcpy (size, "5009");
      }
    else if (nextsymbol () == '6')
      {
	safe_strcpy (size, "6025");
      }
    else
      {
	fatalerror ("Unknown Product Type field");
      }
    do
      {
	readline (temp, sizeof (temp));
      }
    while (!(strstr (temp, ("[Required Layers]"))));
    s = 0;
    while (nextsymbol () != nl)
      {
	read_string (temp);
	read_string (laystr);
	read_string (temp);
	strcat (laystr, " L");
	strcat (laystr, temp);
	read_string (temp);
	strcat (laystr, temp);
	read_string (temp);
	strcat (laystr, " ");
	strcat (laystr, temp);
	s += 1;
	safe_strcpy (lines[s], laystr);
	while (nextsymbol () != nl)
	  skipsymbol ();
	skipsymbol ();
      }
    if (s != max)
      {
	do
	  {
	    readline (temp, sizeof (temp));
	  }
	while (!(strstr (temp, ("[Additional Layers]"))));
	while (nextsymbol () != nl)
	  {
	    read_string (temp);
	    read_string (laystr);
	    read_string (temp);
	    strcat (laystr, " L");
	    strcat (laystr, temp);
	    read_string (temp);
	    strcat (laystr, temp);
	    read_string (temp);
	    strcat (laystr, " ");
	    strcat (laystr, temp);
	    s += 1;
	    safe_strcpy (lines[s], laystr);
	    while (nextsymbol () != nl)
	      skipsymbol ();
	    skipsymbol ();
	  }
      }
  }
  void outputanadata (void)
  {
    int i;
    char grade[255 + 1] = "?", rest[255 + 1];
    char *anascodes (char *size, char *grade)
    {
      if ((strcmp (size, "5009") == 0))
	{
	  if ((strcmp (grade, "A") == 0))
	    return (strdup ("3122\tA1"));
	  if ((strcmp (grade, "B") == 0))
	    return (strdup ("3122\tA2"));
	  if ((strcmp (grade, "C") == 0))
	    return (strdup ("2122\tA1"));
	  if ((strcmp (grade, "D") == 0))
	    return (strdup ("2122\tA2"));
	  if ((strcmp (grade, "E") == 0))
	    return (strdup ("2122\tA3"));
	  if ((strcmp (grade, "F") == 0))
	    return (strdup ("2122\tA4"));
	  if ((strcmp (grade, "G") == 0))
	    return (strdup ("2122\tA5"));
	  if ((strcmp (grade, "H") == 0))
	    return (strdup ("2122\tA6"));
	  if ((strcmp (grade, "I") == 0))
	    return (strdup ("2122\tA7"));
	  if ((strcmp (grade, "D1") == 0))
	    return (strdup ("2122\tA8"));
	  if ((strcmp (grade, "E1") == 0))
	    return (strdup ("2122\tA9"));
	}
      if ((strcmp (grade, "A") == 0))
	return (strdup ("2131\tA1"));
      if ((strcmp (grade, "B") == 0))
	return (strdup ("2131\tA2"));
      if ((strcmp (grade, "C") == 0))
	return (strdup ("2131\tA3"));
      if ((strcmp (grade, "D") == 0))
	return (strdup ("2131\tA4"));
      if ((strcmp (grade, "E") == 0))
	return (strdup ("2131\tA5"));
      if ((strcmp (grade, "F") == 0))
	return (strdup ("2131\tA6"));
      if ((strcmp (grade, "G") == 0))
	return (strdup ("2131\tA7"));
      if ((strcmp (grade, "H") == 0))
	return (strdup ("2131\tA8"));
      if ((strcmp (grade, "I") == 0))
	return (strdup ("2131\tA9"));
      if ((strcmp (grade, "D1") == 0))
	return (strdup ("2131\t10"));
      if ((strcmp (grade, "E1") == 0))
	return (strdup ("2131\t11"));
      fatalerror ("Unknown ANA size or grade - %s \"%s\"", size, grade);
      return (strdup (""));
    }

    char *findgrade (char *layer)
    {
      char name[255 + 1];
      char temp[255 + 1];
//      if (setjmp ())
//      {
//        fatalerror ("Unable to find grade for layer \"%s\" process \"%s\"", layer, process);
//        return (strdup(""));
//      }
      resetinput ();
      for (;;)
	{
	  read_string (name);
	  if (name == layer)
	    {
	      read_string (temp);
	      read_string (temp);
	      return (strdup (temp));
	    }
	  else
	    {
	      readline (temp, sizeof (temp));
	    }
	}
      return (strdup (""));
    }
    char *p;
    imp_tolower (process);
    if (unix == true)
      {
	char tmp[256];
	safe_sprintf (tmp, "/cgi/stdjob/ana/process/nikon_%s.dat", process);
	if (!openinput (2, tmp))
	  {
	    fatalerror ("Unable to open ANA process file for process \"%s\"",
			process);
	  }
      }
    else
      {
	char tmp[256];
	safe_sprintf (tmp, "STD_DIR:[ANA.PROCESS]NIKON_%s.DAT", process);
	if (!openinput (2, tmp))
	  {
	    fatalerror ("Unable to open ANA process file for process \"%s\"",
			process);
	  }
      }
    selectinput (2);
    safe_strcpy (quote, "15787");
    outputheader ("428", max);
    for (i = 1; i <= max; i += 1)
      {
	safe_strcpy (layer, lines (i));

//         %if Layer -> Rest.(" ") %start; %finish
	if ((p = strchr (layer, ' ')) != NULL)
	  {
	    safe_strncpy (rest, layer, p - rest);
	  }
	safe_strcpy (grade, findgrade (rest));
	safe_strcpy (sopcode, anascodes (size, grade));
	if ((strcmp (size, "5009") == 0))
	  {
	    safe_strcpy (description, "5");
	    numrets = 1;
	    numpels = 2;
	  }
	else
	  {
	    safe_strcpy (description, "6");
	    safe_sprintf (layer, "%s%s", description, layer);	// todo: unsafe? recode?
	    numrets = 1;
	    numpels = 1;
	  }
	strcat (description, "\" Reticle + Pellicle Grade ");
	strcat (description, grade);
	outputlineentry (1, device, layer, sopcode, description, numrets,
			 nummast, numsubs, numcopy, numplot, numpels, 'Y',
			 'Y');
      }
    fprintf (outfile, "\n");
  }
  void parseatmelorder ()
  {
    char rest[255 + 1];
    {
//      if (setjmp ())
//      {
//        fatalerror("Unable to extract shipping info - not an official AROMs?");
//      }
      do
	{
	  if (!readline (temp, sizeof (temp)))
	    fatalerror
	      ("Unable to extract shipping info - not an official AROMs?");
	}
      while (!(strstr (temp, ("this order should be shipped to"))));
      if (!readline (temp, sizeof (temp)))
	fatalerror
	  ("Unable to extract shipping info - not an official AROMs?");
      imp_toupper (temp);
      if (strstr (temp, ("COLORADO")))
	{
	  safe_strcpy (site, "COS");
	  return;
	}
      if (strstr (temp, ("ROUSSET")))
	{
	  safe_strcpy (site, "ROU");
	  return;
	}
      if (strstr (temp, ("TYNE")) || strstr (temp, ("KILBRIDE")))
	{
	  safe_strcpy (site, "NTS");
	  return;
	}
      fatalerror ("Unable to decide Atmel site for: %s", temp);
    }
    {
//      if (setjmp ())
//      {
//        fatalerror ("Unexpected end of order when looking for 'Database and mask CD'");
//      }
      do
	{
	  if (!readline (temp, sizeof (temp)))
	    fatalerror
	      ("Unexpected end of order when looking for 'Database and mask CD'");
	}
      while (!(strstr (temp, ("Database and mask CD's"))));
      do
	{
	  if (!readline (temp, sizeof (temp)))
	    fatalerror
	      ("Unexpected end of order when looking for 'Database and mask CD'");
	}
      while (!(strcmp (temp, "")));
      do
	{
	  if (!readline (temp, sizeof (temp)))
	    fatalerror
	      ("Unexpected end of order when looking for 'Database and mask CD'");
	}
      while (!((strcmp (temp, "") == 0)));
    }
    for (;;)
      {
	read_string (rest);
	read_string (device);
	if (strlen (device) < 14)
	  {
	    read_string (layer);
	  }
	else
	  {
	    safe_strcpy (layer, substring (device, 8, 14));
	    safe_strcpy (device, substring (device, 1, 7));
	  }
	do
	  {
	    read_string (temp);
	  }
	while (!(strchr (temp, '.')));
	read_string (temp);
	if (strlen (temp) == 2)
	  read_string (temp);
	read_string (temp);
	read_string (temp);
	readline (rest, sizeof (rest));
	while (nextsymbol () <= ' ')
	  skipsymbol ();
	max += 1;
	safe_strcpy (lines[max], layer);
	safe_strcpy (grades[max], temp);
	if ((!('0' <= nextsymbol () && nextsymbol () <= '9')))
	  break;
      }
  }
  void outputatmeldata ()
  {
    int i;
    char acccode[255 + 1];
    safe_strcpy (quote, "15596");
    if ((strcmp (site, "COS") == 0))
      {
	safe_strcpy (acccode, "410");
      }
    else if ((strcmp (site, "NTS") == 0))
      {
	safe_strcpy (acccode, "411");
      }
    else
      {
	safe_strcpy (acccode, "412");
      }
    outputheader (acccode, max);
    numrets = 1;
    numpels = 1;
    for (i = 1; i <= max; i += 1)
      {
	safe_strcpy (layer, lines (i));
	safe_strcpy (temp, grades (i));
	if ((strcmp (temp, "010") == 0))
	  {
	    safe_strcpy (sopcode, "8131\tA1");
	    safe_strcpy (description, "A, -010");
	  }
	else if ((strcmp (temp, "015") == 0))
	  {
	    safe_strcpy (sopcode, "8131\tA2");
	    safe_strcpy (description, "A, -015");
	  }
	else if ((strcmp (temp, "019") == 0))
	  {
	    safe_strcpy (sopcode, "8131\tA3");
	    safe_strcpy (description, "A, -019");
	  }
	else if ((strcmp (temp, "020") == 0))
	  {
	    safe_strcpy (sopcode, "8131\tA4");
	    safe_strcpy (description, "A, -020");
	  }
	else if ((strcmp (temp, "023") == 0))
	  {
	    safe_strcpy (sopcode, "8131\tA5");
	    safe_strcpy (description, "A, -023");
	  }
	else if ((strcmp (temp, "025") == 0))
	  {
	    safe_strcpy (sopcode, "8131\tA6");
	    safe_strcpy (description, "A, -025");
	  }
	else if ((strcmp (temp, "026") == 0))
	  {
	    safe_strcpy (sopcode, "8131\tA7");
	    safe_strcpy (description, "A, -027");
	  }
	else if ((strcmp (temp, "028") == 0))
	  {
	    safe_strcpy (sopcode, "8131\tA8");
	    safe_strcpy (description, "A, -028");
	  }
	else if ((strcmp (temp, "311") == 0))
	  {
	    safe_strcpy (sopcode, "8231\tB1");
	    safe_strcpy (description, "B, -311");
	  }
	else if ((strcmp (temp, "315") == 0))
	  {
	    safe_strcpy (sopcode, "8231\tB2");
	    safe_strcpy (description, "B, -315");
	  }
	else if ((strcmp (temp, "319") == 0))
	  {
	    safe_strcpy (sopcode, "8231\tB3");
	    safe_strcpy (description, "B, -319");
	  }
	else if ((strcmp (temp, "322") == 0))
	  {
	    safe_strcpy (sopcode, "8231\tB4");
	    safe_strcpy (description, "B, -322");
	  }
	else if ((strcmp (temp, "323") == 0))
	  {
	    safe_strcpy (sopcode, "8231\tB5");
	    safe_strcpy (description, "B, -323");
	  }
	else if ((strcmp (temp, "325") == 0))
	  {
	    safe_strcpy (sopcode, "8231\tB6");
	    safe_strcpy (description, "B, -325");
	  }
	else if ((strcmp (temp, "327") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tB1");
	    safe_strcpy (description, "B, -327");
	  }
	else if ((strcmp (temp, "328") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tB2");
	    safe_strcpy (description, "B, -328");
	  }
	else if ((strcmp (temp, "329") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tB3");
	    safe_strcpy (description, "B, -329");
	  }
	else if ((strcmp (temp, "330") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tB4");
	    safe_strcpy (description, "B, -330");
	  }
	else if ((strcmp (temp, "333") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tB5");
	    safe_strcpy (description, "B, -333");
	  }
	else if ((strcmp (temp, "335") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tB6");
	    safe_strcpy (description, "B, -335");
	  }
	else if ((strcmp (temp, "511") == 0))
	  {
	    safe_strcpy (sopcode, "8231\tC1");
	    safe_strcpy (description, "C, -511");
	  }
	else if ((strcmp (temp, "515") == 0))
	  {
	    safe_strcpy (sopcode, "8231\tC2");
	    safe_strcpy (description, "C, -515");
	  }
	else if ((strcmp (temp, "519") == 0))
	  {
	    safe_strcpy (sopcode, "8231\tC3");
	    safe_strcpy (description, "C, -519");
	  }
	else if ((strcmp (temp, "522") == 0))
	  {
	    safe_strcpy (sopcode, "8231\tC4");
	    safe_strcpy (description, "C, -522");
	  }
	else if ((strcmp (temp, "523") == 0))
	  {
	    safe_strcpy (sopcode, "8231\tC5");
	    safe_strcpy (description, "C, -523");
	  }
	else if ((strcmp (temp, "525") == 0))
	  {
	    safe_strcpy (sopcode, "8231\tC6");
	    safe_strcpy (description, "C, -525");
	  }
	else if ((strcmp (temp, "527") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tC1");
	    safe_strcpy (description, "C, -527");
	  }
	else if ((strcmp (temp, "528") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tC2");
	    safe_strcpy (description, "C, -528");
	  }
	else if ((strcmp (temp, "529") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tC3");
	    safe_strcpy (description, "C, -529");
	  }
	else if ((strcmp (temp, "530") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tC4");
	    safe_strcpy (description, "C, -530");
	  }
	else if ((strcmp (temp, "533") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tC5");
	    safe_strcpy (description, "C, -533");
	  }
	else if ((strcmp (temp, "535") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tC6");
	    safe_strcpy (description, "C, -535");
	  }
	else if ((strcmp (temp, "540") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tC7");
	    safe_strcpy (description, "C, -540");
	  }
	else if ((strcmp (temp, "543") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tC8");
	    safe_strcpy (description, "C, -543");
	  }
	else if ((strcmp (temp, "545") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tC9");
	    safe_strcpy (description, "C, -545");
	  }
	else if ((strcmp (temp, "550") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tD1");
	    safe_strcpy (description, "C, -550");
	  }
	else if ((strcmp (temp, "560") == 0))
	  {
	    safe_strcpy (sopcode, "4231\tD2");
	    safe_strcpy (description, "C, -560");
	  }
	else
	  {
	    warningmessage ("Unknown Atmel Dash code - %s", temp);
	    safe_strcpy (sopcode, "????\t??");
	    safe_sprintf (description, " - %s", temp);
	  }
	if (temp[(1) - 1] == '0')
	  {
	    safe_sprintf (description, "6\" 5X Reticle + Pellicle Table %s", description);	// todo: dangerous, recode?
	  }
	else
	  {
	    safe_sprintf (description, "6\" 4X Reticle + Pellicle Table %s",
		     description);
	  }
	outputlineentry (1, device, layer, sopcode, description, numrets,
			 nummast, numsubs, numcopy, numplot, numpels, 'Y',
			 'Y');
      }
    fprintf (outfile, "\n");
  }
  void outputfcsdata ()
  {
    const int sizepos = 36;
    int i, num5 = 0, num6 = 0, num7 = 0, numprint = 0;
    char p1[255 + 1];
    char p2[255 + 1];
    char thisfile[255 + 1];
    char *p;
//    if (setjmp ())
//      {
//      fatalerror ("Error opening %s", thisfile);
//      }
    safe_strcpy (quote, "16153");
    for (i = 1; i <= max; i += 1)
      {
	safe_strcpy (temp, lines (i));
	if (temp[(sizepos) - 1] == '5')
	  {
	    num5 += 1;
	  }
	else if (temp[(sizepos) - 1] == '6')
	  {
	    num6 += 1;
	  }
	else if (temp[(sizepos) - 1] == '7')
	  {
	    num7 += 1;
	  }
	else
	  {
	    warningmessage ("Unknown plate size: %s", temp);
	  }
	if (strstr (temp, ("Print")))
	  numprint += 1;
      }
    if (num5 > 0)
      {
	safe_sprintf (thisfile, "%s_5.sop", newfile);
	if (!openbinaryoutput (1, thisfile))
	  fatalerror ("Error opening %s", thisfile);
	selectoutput (1);
	outputheader ("407", num5);
	numrets = 1;
	nummast = 0;
	numsubs = 0;
	numcopy = 0;
	numplot = 0;
	if (strstr (comments, ("WITH PEL")))
	  numpels = 2;
	for (i = 1; i <= max; i += 1)
	  {
	    safe_strcpy (temp, lines (i));
	    if (temp[(sizepos) - 1] == '5')
	      {
		if ((p = strchr (temp, ' ')) != NULL)
		  {
		    safe_strncpy (p1, temp, p - temp);
		    safe_strcpy (p2, p + 1);
		  }
		if ((p = strchr (temp, ' ')) != NULL)
		  {
		    *p = '\0';
		  }
		safe_sprintf (layer, "%s %s", p1, p2);
		if (numpels > 0)
		  {
		    if (strstr (temp, ("0.25")))
		      {
			safe_strcpy (sopcode, "3122\tA1");
			safe_strcpy (description,
				"5\" 5X Reticle + Pellicles (Non Critical)");
		      }
		    else
		      {
			safe_strcpy (sopcode, "2122\tA1");
			safe_strcpy (description,
				"5\" 5X Reticle + Pellicles (Critical)");
		      }
		  }
		else
		  {
		    if (strstr (temp, ("0.25")))
		      {
			safe_strcpy (sopcode, "3120\tA1");
			safe_strcpy (description, "5\" 5X Reticle (Non Critical)");
		      }
		    else
		      {
			safe_strcpy (sopcode, "2120\tA1");
			safe_strcpy (description, "5\" 5X Reticle (Critical)");
		      }
		  }
		outputlineentry (1, device, layer, sopcode, description,
				 numrets, nummast, numsubs, numcopy, numplot,
				 numpels, 'Y', 'Y');
	      }
	  }
	fprintf (outfile, "\n");
	closeoutput ();
	reportcreationof (thisfile);
      }
    if (num6 > 0)
      {
	safe_sprintf (thisfile, "%s_6.sop", newfile);
	if (!openbinaryoutput (1, thisfile))
	  fatalerror ("Error opening %s", thisfile);
	selectoutput (1);
	outputheader ("407", num6);
	numrets = 1;
	nummast = 0;
	numsubs = 0;
	numcopy = 0;
	numplot = 0;
	numpels = 1;
	for (i = 1; i <= max; i += 1)
	  {
	    safe_strcpy (temp, lines (i));
	    if (temp[(sizepos) - 1] == '6')
	      {
		if ((p = strchr (temp, ' ')) != NULL)
		  {
		    safe_strncpy (p1, temp, p - temp);
		    safe_strcpy (p2, p + 1);
		  }
		if ((p = strchr (p2, ' ')) != NULL)
		  {
		    *p = '\0';
		  }
		safe_sprintf (layer, "%s %s", p1, p2);
		if (strstr (temp, ("0.25")))
		  {
		    safe_strcpy (sopcode, "4131\tA1");
		    safe_strcpy (description, "6\" 5X Reticle + Pellicle Grade A");
		  }
		else if (strstr (temp, ("0.15")))
		  {
		    safe_strcpy (sopcode, "4131\tA2");
		    safe_strcpy (description, "6\" 5X Reticle + Pellicle Grade B");
		  }
		else if (strstr (temp, ("0.1")))
		  {
		    safe_strcpy (sopcode, "4131\tA3");
		    safe_strcpy (description, "6\" 5X Reticle + Pellicle Grade C");
		  }
		else if (strstr (temp, ("0.08")))
		  {
		    safe_strcpy (sopcode, "4131\tA5");
		    safe_strcpy (description, "6\" 5X Reticle + Pellicle Grade E");
		  }
		else if (strstr (temp, ("0.05")))
		  {
		    safe_strcpy (sopcode, "4131\tA6");
		    safe_strcpy (description, "6\" 5X Reticle + Pellicle Grade F");
		  }
		outputlineentry (1, device, layer, sopcode, description,
				 numrets, nummast, numsubs, numcopy, numplot,
				 numpels, 'Y', 'Y');
	      }
	  }
	fprintf (outfile, "\n");
	closeoutput ();
	reportcreationof (thisfile);
      }
    if (num7 > 0)
      {
	safe_sprintf (thisfile, "%s_7.sop", newfile);
	if (!openbinaryoutput (1, thisfile))
	  fatalerror ("Error opening %s", thisfile);
	selectoutput (1);
	outputheader ("407", num7 + numprint);
	numrets = 0;
	nummast = 1;
	numsubs = 0;
	numpels = 0;
	for (i = 1; i <= max; i += 1)
	  {
	    safe_strcpy (temp, lines (i));
	    if (temp[(sizepos) - 1] == '7')
	      {
		if ((p = strchr (temp, ' ')) != NULL)
		  {
		    safe_strncpy (p1, temp, p - temp);
		    safe_strcpy (p2, p + 1);
		  }
		if ((p = strchr (temp, ' ')) != NULL)
		  {
		    *p = '\0';
		  }
		safe_sprintf (layer, "%s %s", p1, p2);
		if (strstr (temp, ("Print")))
		  {
		    safe_strcpy (sopcode, "3190\tA2");
		    safe_strcpy (description, "7\" 1X Master For Copies");
		    numcopy = 1;
		    outputlineentry (1, device, layer, sopcode, description,
				     numrets, nummast, numsubs, numcopy,
				     numplot, numpels, 'Y', 'N');
		    safe_strcpy (sopcode, "5590\tA1");
		    safe_strcpy (description, "Iron Oxide Copy");
		    outputlineentry (1, device, layer, sopcode, description,
				     0, 0, 0, 1, 0, 0, 'N', 'Y');
		  }
		else
		  {
		    safe_strcpy (sopcode, "3190\tA1");
		    safe_strcpy (description, "7\" 1X Front Side Master");
		    numcopy = 0;
		    outputlineentry (1, device, layer, sopcode, description,
				     numrets, nummast, numsubs, numcopy,
				     numplot, numpels, 'Y', 'Y');
		  }
	      }
	  }
	fprintf (outfile, "\n");
	closeoutput ();
	reportcreationof (thisfile);
      }
    strcat (newfile, "*.sop");
  }
  void parsemieorder ()
  {
    int s;
    char a[255 + 1];
    char b[255 + 1];
    char type[255 + 1];
    char grade[255 + 1];
    do
      {
	read_string (a);
      }
    while (!((strcmp (a, "reticle,type") == 0)));
    while (nextsymbol () <= ' ')
      skipsymbol ();
    safe_strcpy (type, "");
    {
      char *typep = type;
      *typep = '\0';
      for (;;)
	{
	  readsymbol (&s);
	  *typep++ = s;
	  if (s == ' ' && nextsymbol () == ' ')
	    break;
	}
      *typep = '\0';
    }
    type[strlen (type) - 1] = '\0';	// trim last char off?
    if (strstr (type, ("1550")))
      {
	safe_strcpy (grade, "5A");
      }
    else
      {
	if (strstr (type, ("2000")))
	  {
	    safe_strcpy (grade, "5B");
	  }
	else
	  {
	    safe_strcpy (grade, "1");
	  }
      }
    do
      {
	readline (a, sizeof (a));
      }
    while (!(strstr (a, ("Reading sense of Mask Titles"))));
    for (s = 1; s <= 3; s += 1)
      readline (a, sizeof (a));
    for (;;)
      {
	read_string (a);
	if (strstr (a, ("______")))
	  break;
	read_string (device);
	read_string (b);
	max += 1;
	safe_strcpy (lines[max], b);
	safe_strcpy (grades[max], grade);
	readline (b, sizeof (b));
	while (nextsymbol () <= ' ')
	  skipsymbol ();
      }
  }
  void outputmiedata ()
  {
    int i;
    char grade[255 + 1];
    const char codes5['J' - 'A' + 1][3 + 1];
#define codes5(n) codes5[(n)-'A']
    const char codes1['E' - 'A' + 1][3 + 1];
#define codes1(n) codes1[(n)-'A']
    safe_strcpy (quote, "15090I");
    outputheader ("777", max);
    for (i = 1; i <= max; i += 1)
      {
	safe_strcpy (layer, lines (i));
	safe_strcpy (grade, grades (i));
	if (grade[(1) - 1] == '5')
	  {
	    safe_sprintf (sopcode, "2122\t%s", codes5 (grade[(2) - 1]));
	    safe_sprintf (description, "5\" 5x Reticle + Pellicles Grade %s",
		     grade);
	    numrets = 1;
	    numpels = 2;
	  }
	else
	  {
	    nummast = 1;
	    if ((strcmp (grade, "1A") == 0) || (strcmp (grade, "1B") == 0))
	      {
		safe_sprintf (sopcode, "3160\t%s", codes1 (grade[(2) - 1]));
		safe_sprintf (description, "5\" x 0.090\", 1X Array Grade %s",
			 grade);
	      }
	    else
	      {
		safe_strcpy (sopcode, "2161\tA1");
		safe_sprintf (description, "5\" x 0.090\", 1X + Pellicle Grade %s",
			 grade);
		numpels = 1;
	      }
	  }
	outputlineentry (1, device, layer, sopcode, description, numrets,
			 nummast, numsubs, numcopy, numplot, numpels, 'Y',
			 'Y');
      }
    fprintf (outfile, "\n");
  }
  void parsenwlorder ()
  {
    int i;
    char line[255 + 1];
    char rest[255 + 1];
    char lev[255 + 1];
    do
      {
	read_string (line);
      }
    while (!((strcmp (line, "Device") == 0)));
    read_string (device);
    do
      {
	read_string (line);
      }
    while (!((strcmp (line, "Material") == 0)));
    read_string (line);
    read_string (size);
    do
      {
	readline (line, sizeof (line));
      }
    while (!(strstr (line, ("|Layer |"))));
    readline (line, sizeof (line));
    readline (line, sizeof (line));
    for (;;)
      {
	readline (line, sizeof (line));
	if (strstr (line, ("_______")))
	  break;
	max += 1;
	safe_strcpy (lines[max], substring (line, 35, 41));
	safe_strcpy (grades[max], "");
      }
    if (!(strstr (size, ("7x7"))))
      {
	do
	  {
	    readline (line, sizeof (line));
	  }
	while (!(strstr (line, ("| Layer |"))));
	readline (line, sizeof (line));
	readline (line, sizeof (line));
	for (;;)
	  {
	    read_string (lev);
	    safe_strcpy (lev, substring (lev, 2, 4));	// todo: be careful
	    if ((strcmp (lev, "___") == 0))
	      break;
	    for (i = 1; i <= 9; i += 1)
	      read_string (line);
	    readline (rest, sizeof (rest));
	    for (i = 1; i <= max; i += 1)
	      {
		if (lev == substring (lines (i), 5, 7))
		  {
		    safe_strcpy (grades[i], line);
		    break;
		  }
		else if (i == max)
		  {
		    fatalerror ("Unable to extract grade for layer %s", lev);
		  }
	      }
	  }
      }
  }
  void outputnwldata ()
  {
    int i;
    char grade[255 + 1];
    safe_strcpy (quote, "15427B");
    outputheader ("436", max);
    for (i = 1; i <= max; i += 1)
      {
	safe_strcpy (layer, lines (i));
	safe_strcpy (grade, grades (i));
	if (strstr (size, ("6x6")))
	  {
	    safe_sprintf (sopcode, "2122\tA%c", grade[(strlen (grade) - 1) - 1]);
	    safe_sprintf (description, "6\" Reticle + Pellicle %s", grade);
	    numrets = 1;
	    numpels = 1;
	  }
	else if (strstr (size, ("5x5")))
	  {
	    safe_sprintf (sopcode, "3122\tA%c", grade[(strlen (grade) - 1) - 1]);
	    safe_sprintf (description, "5\" Reticle + Pellicles %s", grade);
	    numrets = 1;
	    numpels = 2;
	  }
	else
	  {
	    safe_strcpy (sopcode, "3190\tA1");
	    safe_strcpy (description, "7\" x 120\", 1X Array");
	    nummast = 1;
	    numpels = 1;
	  }
	outputlineentry (1, device, layer, sopcode, description, numrets,
			 nummast, numsubs, numcopy, numplot, numpels, 'Y',
			 'Y');
      }
    fprintf (outfile, "\n");
  }
  void outputnatdata ()
  {
    int i;
    char *p;
    safe_strcpy (quote, "15824A");
    outputheader ("700", max);
    for (i = 1; i <= max; i += 1)
      {
	safe_strcpy (temp, lines (i));
	if ((p = strchr (temp, ' ')) != NULL)
	  {
	    safe_strncpy (layer, temp, p - temp);
	    safe_strcpy (temp, p + 1);	// todo prevent overlap
	  }
	if (layer == device)
	  {
	    if ((p = strchr (temp, ' ')) != NULL)
	      {
		safe_strncpy (layer, temp, p - temp);
	      }
	  }
	if ((strcmp (size, "5/90") == 0))
	  {
	    safe_strcpy (sopcode, "2122\tA1");
	    safe_strcpy (description, "5\" 5X ASM Reticle + Pellicles");
	    numrets = 1;
	    numpels = 2;
	  }
	else
	  {
	    safe_strcpy (sopcode, "2181\tA1");
	    safe_strcpy (description, "7.25R 1X Master + Pellicle");
	    nummast = 1;
	    numpels = 1;
	  }
	outputlineentry (1, device, layer, sopcode, description, numrets,
			 nummast, numsubs, numcopy, numplot, numpels, 'Y',
			 'Y');
      }
    fprintf (outfile, "\n");
  }
  void outputstcdata ()
  {
    int i;
    char temp[255 + 1];
    char *p;

    char *stcscodes (char *cmcnum)
    {
      if ((strcmp (cmcnum, "2CMC9066") == 0))
	return (strdup ("2131\tA1"));
      if ((strcmp (cmcnum, "2CMC2217") == 0))
	return (strdup ("2131\tA3"));
      if ((strcmp (cmcnum, "2CMC2733") == 0))
	return (strdup ("2131\tA4"));
      if ((strcmp (cmcnum, "2CMC2218") == 0))
	return (strdup ("2131\tA5"));
      if ((strcmp (cmcnum, "2CMC2430") == 0))
	return (strdup ("2131\tA7"));
      if ((strcmp (cmcnum, "2CMC2227") == 0))
	return (strdup ("2131\tA8"));
      if ((strcmp (cmcnum, "2CMC2186") == 0))
	return (strdup ("2131\tA9"));
      if ((strcmp (cmcnum, "2CMC2735") == 0))
	return (strdup ("2131\tB2"));
      if ((strcmp (cmcnum, "2CMC2734") == 0))
	return (strdup ("2131\tB3"));
      if ((strcmp (cmcnum, "2CMC2736") == 0))
	return (strdup ("2131\tB4"));
      if ((strcmp (cmcnum, "2CMC2433") == 0))
	return (strdup ("2131\tB6"));
      if ((strcmp (cmcnum, "2CMC2435") == 0))
	return (strdup ("2131\tB7"));
      if ((strcmp (cmcnum, "2CMC1845") == 0))
	return (strdup ("2131\tB8"));
      if ((strcmp (cmcnum, "2CMC1831") == 0))
	return (strdup ("2131\tC1"));
      if ((strcmp (cmcnum, "2CMC0099") == 0))
	return (strdup ("2131\tC2"));
      if ((strcmp (cmcnum, "2CMC2801") == 0))
	return (strdup ("2231\tA1"));
      if ((strcmp (cmcnum, "2CMC2804") == 0))
	return (strdup ("2231\tA2"));
      if ((strcmp (cmcnum, "2CMC2805") == 0))
	return (strdup ("2231\tA3"));
      if ((strcmp (cmcnum, "2CMC2808") == 0))
	return (strdup ("2231\tA4"));
      if ((strcmp (cmcnum, "2CMC8860") == 0))
	return (strdup ("2231\tA7"));
      if ((strcmp (cmcnum, "2CMC8866") == 0))
	return (strdup ("2231\tA8"));
      if ((strcmp (cmcnum, "2CMC9980") == 0))
	return (strdup ("2231\tA9"));
      if ((strcmp (cmcnum, "2CMC9989") == 0))
	return (strdup ("2231\tB1"));
      if ((strcmp (cmcnum, "2CMC8863") == 0))
	return (strdup ("2231\tB2"));
      if ((strcmp (cmcnum, "2CMC8861") == 0))
	return (strdup ("2231\tB3"));
      if ((strcmp (cmcnum, "2CMC0104") == 0))
	return (strdup ("2231\tB4"));
      if ((strcmp (cmcnum, "2CMC2823") == 0))
	return (strdup ("2231\tB6"));
      if ((strcmp (cmcnum, "2CMC8858") == 0))
	return (strdup ("2231\tB7"));
      if ((strcmp (cmcnum, "2CMC3059") == 0))
	return (strdup ("2231\tB8"));
      if ((strcmp (cmcnum, "2CMC2807") == 0))
	return (strdup ("4231\tA1"));
      if ((strcmp (cmcnum, "2CMC9982") == 0))
	return (strdup ("4231\tA2"));
      return (strdup ("????\t??"));
    }
    outputheader ("712", max);
    for (i = 1; i <= max; i += 1)
      {
	safe_strcpy (temp, lines (i));
	safe_sprintf (layer, "%c%c%c%c %c%c%c",
		 temp[(1) - 1],
		 temp[(2) - 1],
		 temp[(9) - 1],
		 temp[(10) - 1],
		 temp[(14) - 1], temp[(15) - 1], temp[(16) - 1]);
	if ((p = strstr (temp, "2CMC")) != NULL)
	  {
	    safe_strcpy (s1, p + strlen ("2CMC"));
	  }
	if ((p = strchr (s1, ' ')) != NULL)
	  {
	    *p = '\0';
	  }
	safe_sprintf (cmcnum, "2CMC%s", s1);
	safe_strcpy (sopcode, stcscodes (cmcnum));
	safe_strcpy (description, cmcnum);
	numrets = 1;
	numpels = 1;
	outputlineentry (1, device, layer, sopcode, description, numrets,
			 nummast, numsubs, numcopy, numplot, numpels, 'Y',
			 'Y');
      }
    fprintf (outfile, "\n");
  }
  void outputphdata ()
  {
    int i;
    char temp[255 + 1];
    char grade[255 + 1];
    char *p;

    char *phscode (char *grade)
    {
      char result[3];
      if ('1' <= grade[(2) - 1] && grade[(2) - 1] <= '7')
	{
	  safe_sprintf (result, "A%c", grade[(2) - 1]);
	  return (strdup (result));
	}
      if ((strcmp (grade, "QE") == 0))
	return ("A8");
      if ((strcmp (grade, "QF") == 0))
	return ("A9");
      if ((strcmp (grade, "QG") == 0))
	return ("B1");
      if ((strcmp (grade, "Q9") == 0))
	return ("B2");
      return ("??");
    }
    if ((strcmp (custcode, "PH2") == 0))
      safe_strcpy (site, "Mos2");
    else
      safe_strcpy (site, "Mos34");
    safe_strcpy (quote, "15525");
    outputheader ("432", max);
    imp_toupper (device);
    for (i = 1; i <= max; i += 1)
      {
	safe_strcpy (temp, lines (i));
	if ((strcmp (custcode, "PH2") == 0)
	    || (strcmp (custcode, "PH3") == 0))
	  {
	    if ((p = strchr (temp, ' ')) != NULL)
	      {
		safe_strncpy (layer, temp, p - temp);
	      }
	  }
	else if ((strcmp (custcode, "PH4") == 0))
	  {
	    safe_strcpy (layer, substring (temp, 1, 6));
	  }
	else
	  {
	    fatalerror ("Unknown Philips code %s", custcode);
	  }
	if ((p = strstr (temp, " = Q")) != NULL)
	  {
	    safe_strcpy (temp, p + strlen (" = Q"));	//todo overlap
	  }
	safe_sprintf (grade, "Q%c", temp[(1) - 1]);
	if ((strcmp (custcode, "PH2") == 0) && strcmp (size, "6/250"))
	  {
	    safe_strcpy (sopcode, "3201\tA1");
	    safe_strcpy (description, "Ultratech Reticle + Pellicle");
	    safe_strcpy (quote, "15528");
	  }
	else if ((strcmp (size, "5/90") == 0))
	  {
	    safe_sprintf (sopcode, "2122\t%s", phscode (grade));
	    safe_sprintf (description,
		     "5\" x 0.900\", 5X DSW Reticle + Pellicles %s", grade);
	  }
	else
	  {
	    safe_sprintf (sopcode, "2131\t%s", phscode (grade));
	    safe_sprintf (description, "6\" x 0.25\" 5X Reticle + Pellicle %s",
		     grade);
	  }
	numrets = 1;
	numpels = 1;
	outputlineentry (1, device, layer, sopcode, description, numrets,
			 nummast, numsubs, numcopy, numplot, numpels, 'Y',
			 'Y');
      }
    fprintf (outfile, "\n");
  }
  void parsermtorder ()
  {
    int s;
    char a[255 + 1];
    char b[255 + 1];
    char *p;

    do
      {
	readitem (ponumber);
      }
    while (!(strcmp (ponumber, "")));
    do
      {
	readitem (device);
      }
    while (!((strcmp (device, "Mask name") == 0)));
    do
      {
	readsymbol (&s);
      }
    while (!(s == nl));
    max = 0;
    for (;;)
      {
	readitem (temp);
	readitem (temp);
	if ((strcmp (temp, "") == 0))
	  break;
	safe_strcpy (device, temp);
	while ((p = strstr (device, "  ")) != NULL)
	  {
	    safe_strncpy (a, device, p - device);
	    safe_strcpy (b, p + strlen ("  "));
	    safe_sprintf (device, "%s %s", a, b);	// todo - be careful
	  }
//         %if Device -> Device.(" ").Layer %start
	if ((p = strchr (device, ' ')) != NULL)
	  {
	    *p++ = '\0';
	    safe_strcpy (layer, p);
	  }
	else if ((p = strchr (device, '_')) != NULL)
	  {
	    *p++ = '\0';
	    safe_strcpy (layer, p);
	  }
	else if ((p = strchr (device, '/')) != NULL)
	  {
	    *p++ = '\0';
	    safe_strcpy (layer, p);
	  }
	else
	  {
	    fatalerror ("Unknown format for Mask name - \"%s\"", device);
	  }
	max += 1;
	safe_sprintf (lines[max], "%s %s", device, layer);
	readitem (temp);
	readitem (temp);
	readitem (temp);
	readitem (temp);
	readitem (temp);
	readitem (temp);
	if ((strcmp (temp, "M") != 0) && (strcmp (temp, "C") != 0))
	  {
	    fatalerror ("Unknown M/C value - \"%s\"", temp);
	  }
	mc[max] = temp[(1) - 1];
	readitem (temp);
	readitem (size);
	readitem (temp);
	quantities[max] = atoi (temp);
	do
	  {
	    readsymbol (&s);
	  }
	while (!(s == nl));
      }
    do
      {
	readitem (temp);
      }
    while (!((strcmp (temp, "Order from") == 0)));
    do
      {
	readitem (temp);
      }
    while (!((strcmp (temp, "At site") == 0)));
    readitem (temp);
    if ((strcmp (temp, "D") == 0))
      {
	safe_strcpy (site, "Germany");
      }
    else if ((strcmp (temp, "CH") == 0))
      {
	safe_strcpy (site, "Switz");
      }
    else
      {
	fatalerror ("Unknown Delivery site - \"%c\"", temp);
      }
    do
      {
	readitem (temp);
      }
    while (!((strcmp (temp, "Invoice to") == 0)));
    readitem (temp);
    if ((strcmp (temp, "D") == 0))
      {
	safe_strcpy (invoice, "474");
      }
    else if ((strcmp (temp, "CH") == 0))
      {
	safe_strcpy (invoice, "444");
      }
    else
      {
	fatalerror ("Unknown Invoice site - \"%s\"", temp);
      }
  }
  void outputrmtdata ()
  {
    int i;
    int deliver;
    int numrecords;
    char lastdevice[255 + 1];
    char thisdevice[255 + 1];
    char *p;

    if ((strcmp (size, "4006") == 0))
      {
	safe_strcpy (sopcode, "3210\tA2");
	safe_strcpy (description, "4\" Ebeam Master 8um");
      }
    else if ((strcmp (size, "5009") == 0))
      {
	safe_strcpy (sopcode, "3160\tA2");
	safe_strcpy (description, "5\" Ebeam Master 8um");
      }
    else if ((strcmp (size, "6012") == 0))
      {
	safe_strcpy (sopcode, "3170\tA2");
	safe_strcpy (description, "6\" Ebeam Master 8um");
      }
    else if ((strcmp (size, "7012") == 0))
      {
	safe_strcpy (sopcode, "3190\tA1");
	safe_strcpy (description, "7\" Ebeam Master 8um");
      }
    safe_strcpy (quote, "15860");
    numrecords = max + 1;
    safe_strcpy (lastdevice, lines (1));
    for (i = 1; i <= max; i += 1)
      {
	if ((mc (i) & 95) != 'M')
	  {
	    numrecords += 1;
	  }
	if ((p = strchr (lines (i), ' ')) != NULL)
	  {
	    safe_strncpy (thisdevice, lines (i), p - lines (i));
	  }
	if (lastdevice != thisdevice)
	  safe_strcpy (lastdevice, "Mixed");
      }
    outputheader (invoice, numrecords);
    if ((strcmp (lastdevice, "Mixed") == 0))
      safe_strcpy (device, "");
    outputlineentry (1, device, "", "1010\tA1",
		     "Data Conversion from GDSII", 0, 0, 0, 0, 0, 0, 'N',
		     'N');
    for (i = 1; i <= max; i += 1)
      {
	if ((p = strchr (lines (i), ' ')) != NULL)
	  {
	    safe_strncpy (device, lines (i), p - lines (i));
	    safe_strcpy (layer, p + 1);
	  }
	if ((mc (i) & 95) == 'M')
	  {
	    numcopy = 0;
	    nummast = quantities (i);
	    deliver = 'Y';
	  }
	else
	  {
	    numcopy = quantities (i);
	    nummast = 1;
	    deliver = 'N';
	  }
	outputlineentry (1, device, layer, sopcode, description, numrets,
			 nummast, numsubs, numcopy, numplot, numpels, 'Y',
			 deliver);
      }
    if (numcopy != 0)
      {
	if ((strcmp (size, "4006") == 0))
	  {
	    safe_strcpy (sopcode, "5470\tA1");
	    safe_strcpy (description, "4\" Chrome Copy");
	  }
	else if ((strcmp (size, "5009") == 0))
	  {
	    safe_strcpy (sopcode, "5480\tA1");
	    safe_strcpy (description, "5\" Chrome Copy");
	  }
	else if ((strcmp (size, "6012") == 0))
	  {
	    safe_strcpy (sopcode, "5490\tA1");
	    safe_strcpy (description, "6\" Chrome Copy");
	  }
	else if ((strcmp (size, "7012") == 0))
	  {
	    safe_strcpy (sopcode, "5500\tA1");
	    safe_strcpy (description, "7\" Chrome Copy");
	  }
	for (i = 1; i <= max; i += 1)
	  {
	    if ((p = strchr (lines (i), ' ')) != NULL)
	      {
		safe_strncpy (device, lines (i), p - lines (i));
		safe_strcpy (layer, p + 1);
	      }
	    outputlineentry (numcopy, device, layer, sopcode, description, 0,
			     0, 0, 0, 0, 0, 'N', 'Y');
	  }
      }
    fprintf (outfile, "\n");
  }
  void parsetslorder ()
  {
    int i;
    int s;
    char temp[255 + 1];
    char title[255 + 1];
    do
      {
	read_string (temp);
      }
    while (!((strcmp (temp, "DEVICE:") == 0)));
    while (nextsymbol () == ' ' || nextsymbol () == '.')
      skipsymbol ();
    read_string (device);
    do
      {
	read_string (temp);
      }
    while (!((strcmp (temp, "GLASS") == 0)));
    do
      {
	read_string (temp);
      }
    while (!((strcmp (temp, "GLASS") == 0)));
    read_string (temp);
    while (nextsymbol () == ' ' || nextsymbol () == '.')
      skipsymbol ();
    *size = nextsymbol ();
    size[1] = '\0';
    if ((strcmp (size, "7") == 0))
      {
	safe_sprintf (file, "1X_%s", file);	// todo - fix
      }
    else
      {
	safe_sprintf (file, "5X_%s", file);	// todo - fix
      }
    do
      {
	readline (temp, sizeof (temp));
      }
    while (!(strstr (temp, ("SCALE FACTOR"))));
    do
      {
	readline (temp, sizeof (temp));
      }
    while (!(strstr (temp, ("|CL/DK|"))));
    readline (temp, sizeof (temp));
    for (;;)
      {
	do
	  {
	    readsymbol (&s);
	  }
	while (!(s == '|'));
	do
	  {
	    readsymbol (&s);
	  }
	while (!(s == '|'));
	while (nextsymbol () == ' ')
	  skipsymbol ();
	{
	  char *titlep = title;
	  *titlep = '\0';
	  for (;;)
	    {
	      readsymbol (&s);
	      if (s == '|')
		break;
	      *titlep++ = s;
	    }
	  *titlep = '\0';
	}
	for (i = 1; i <= 6; i += 1)
	  {
	    do
	      {
		readsymbol (&s);
	      }
	    while (!(s == '|'));
	  }
	while (nextsymbol () == ' ')
	  skipsymbol ();
	readline (temp, sizeof (temp));
	max += 1;
	safe_sprintf (lines[max], "%c_%s", temp[(2) - 1], title);
	if (nextsymbol () == '+')
	  break;
      }
  }
  void outputtsldata ()
  {
    int i;
    int grade;
    char *p;

    safe_strcpy (quote, "15726A");
    outputheader ("708", max);
    for (i = 1; i <= max; i += 1)
      {
	safe_strcpy (temp, lines (i));
	grade = temp[(1) - 1];
	if ((p = strchr (temp, '_')) != NULL)
	  {
	    safe_strcpy (temp, p + 1);	//todo overlap
	  }
	if ((p = strchr (temp, ' ')) != NULL)
	  {
	    safe_strcpy (layer, p + 1);
	  }
	if ((strcmp (size, "5") == 0))
	  {
	    safe_sprintf (sopcode, "2122\tA%c", grade - 'A' + '1');
	    safe_sprintf (description, "5\" Reticle + Pellicle Grade 5%c", grade);
	    numrets = 1;
	    numpels = 2;
	  }
	else if ((strcmp (size, "6") == 0))
	  {
	    fatalerror ("6\" TSL product not yet implememted");
	    safe_sprintf (description, "1\" Reticle + Pellicle Grade 5%c", grade);
	    numrets = 1;
	    numpels = 1;
	  }
	else
	  {
	    safe_sprintf (sopcode, "2181\tA%c", grade - 'A' + '1');
	    safe_sprintf (description, "7.25\" Master + Pellicle Grade 1%c",
		     grade);
	    nummast = 1;
	    numpels = 1;
	  }
	outputlineentry (1, device, layer, sopcode, description, numrets,
			 nummast, numsubs, numcopy, numplot, numpels, 'Y',
			 'Y');
      }
    fprintf (outfile, "\n");
  }
  void parsevtiorder ()
  {
    int i;
//    int s;
    char temp[255 + 1];
    char a[255 + 1];
    char b[255 + 1];
    char *p;

    do
      {
	read_string (temp);
      }
    while (!((strcmp (temp, "#:") == 0)));
    read_string (ponumber);
    do
      {
	read_string (temp);
      }
    while (!((strcmp (temp, "Title:") == 0)));
    readitem (device);
    imp_toupper (device);
    while ((p = strchr (device, '\n')) != NULL)
      {
	safe_strncpy (a, device, p - device);
	safe_strcpy (b, p + 1);
	safe_sprintf (device, "%s%s", a, b);
      }
    do
      {
	read_string (temp);
      }
    while (!((strcmp (temp, "\"Substrate:") == 0)));
    read_string (process);
    for (i = 1; i <= 7; i += 1)
      readline (temp, sizeof (temp));
    for (;;)
      {
	readitem (temp);
	readitem (temp);
	while ((p = strchr (temp, '"')) != NULL)
	  {
	    safe_strncpy (a, temp, p - temp);
	    safe_strcpy (b, p + 1);
	    safe_sprintf (temp, "%s%s", a, b);
	  }
	while ((p = strchr (temp, '\n')) != NULL)
	  {
	    safe_strncpy (a, temp, p - temp);
	    safe_strcpy (b, p + 1);
	    safe_sprintf (temp, "%s%s", a, b);
	  }
	imp_toupper (temp);
	if (strlen (temp) > strlen (device)
	    && device == substring (temp, 1, strlen (device)))
	  {
	    safe_strcpy (temp,
		    substring (temp, strlen (device) + 1, strlen (temp)));
	    if (temp[(1) - 1] == ' ')
	      {
		safe_strcpy (temp, substring (temp, 2, strlen (temp)));
	      }
	  }
	if ((strcmp (temp, "") == 0))
	  break;
	max += 1;
	safe_strcpy (lines[max], temp);
	readitem (temp);
	readitem (temp);
	readitem (temp);
	readitem (temp);
	readitem (temp);
	readitem (temp);
	safe_strcpy (grades[max], temp);
	readitem (temp);
	safe_strcpy (tols[max], temp);
	readline (temp, sizeof (temp));
	mc[max] = temp[(strlen (temp) - 1) - 1];
      }
  }
  void outputvtidata ()
  {
    int i;
    char material[255 + 1];
    char reprint[255 + 1];
    char grade[255 + 1];
    char tol[255 + 1];
    char code[255 + 1];
    safe_strcpy (quote, "15635A");
    outputheader ("064", max);
    nummast = 1;
    for (i = 1; i <= max; i += 1)
      {
	safe_strcpy (layer, lines (i));
	safe_strcpy (grade, grades (i));
	safe_strcpy (tol, tols (i));
	if (strstr (process, ("LTE")))
	  {
	    safe_strcpy (material, "SL ");
	  }
	else
	  {
	    safe_strcpy (material, "QZ ");
	  }
	if (mc (i) == 'n')
	  {
	    safe_strcpy (reprint, "");
	    strcat (layer, " 001");
	  }
	else
	  {
	    safe_strcpy (reprint, "REPRINT ");
	    strcat (layer, " 00?");
	  }
	if ((strcmp (material, "SL ") == 0))
	  {
	    if (strcmp (reprint, ""))
	      {
		safe_strcpy (code, "A3");
	      }
	    else
	      {
		if ((strcmp (grade, "I") == 0))
		  safe_strcpy (code, "A1");
		else
		  safe_strcpy (code, "A2");
	      }
	  }
	else if (strstr (tol, ("0.1")))
	  {
	    if (strcmp (reprint, ""))
	      {
		safe_strcpy (code, "B1");
	      }
	    else
	      {
		safe_strcpy (code, "A9");
	      }
	  }
	else
	  {
	    if (strcmp (reprint, ""))
	      {
		if ((strcmp (grade, "I") == 0))
		  safe_strcpy (code, "A7");
		else
		  safe_strcpy (code, "A8");
	      }
	    else
	      {
		if ((strcmp (grade, "I") == 0))
		  safe_strcpy (code, "A5");
		else
		  safe_strcpy (code, "A6");
	      }
	  }
	safe_sprintf (sopcode, "2190\t%s", code);
	safe_sprintf (description, "7\" x 0.120\", 1X Array %s%sClass %s",
		 material, reprint, grade);
	outputlineentry (1, device, layer, sopcode, description, numrets,
			 nummast, numsubs, numcopy, numplot, numpels, 'Y',
			 'Y');
      }
  }
  char *p;

//  if (setjmp ())
//    {
//      fatalerror ("Unable to process file %s", file);
//    }
  imp_init (argc, argv);
  if (qualifierpresent ("TEST"))
    {
      fprintf (stderr, "Date: %s\n", numdate ());
      fprintf (stderr, "Date[1..2]: %s\n", substring(numdate (),1,2));
      exit (0);
    }
  if (qualifierpresent ("IDENTIFY"))
    {
      printidentification ();
      if (!(qualifierpresent ("FILE")))
	exit (1);
    }
  if (strchr (translate ("TEC"), '['))
    unix = false;
  safe_strcpy (file, qualifiers ("FILE"));
  if ((strcmp (file, "") == 0))
    {
      spawncommand ("ls *.*");
      selectinput (0);
      prompt ("Enter Order form summary file: ");
      readline (file, sizeof (file));
    }
  if (strstr (file, ("NAT.DIR")))
    {
      safe_strcpy (file, "");
      if (qualifierpresent ("SEND"))
	safe_strcpy (file, "/SEND");
      if (qualifierpresent ("DELETE"))
	strcat (file, "/DELETE");
      spawncommand ("dir/out=sys$login:sop_import.log *.txt;");
      if (!openinput (1, "sys$login:sop_import.log"))
	fatalerror ("Unable to process file %s", file);
      selectinput (1);
      for (i = 1; i <= 3; i += 1)
	if (!readline (temp, sizeof (temp)))
	  fatalerror ("Unable to process file %s", file);
      for (;;)
	{
	  read_string (temp);
	  if ((strcmp (temp, "Total") == 0))
	    break;
	  spawncommand ("SOP_IMPORT %s%s", temp, file);
	}
      closeinput ();
      spawncommand ("delete/nolog sys$login:sop_import.log;");
      exit (0);
    }
  if (!openinput (1, file))
    fatalerror ("Unable to process file %s", file);
  selectinput (1);
  read_string (temp);
  if ((strcmp (temp, "Project") == 0))
    {
      safe_strcpy (custcode, "STC");
      safe_strcpy (site, "Crolles");
      safe_strcpy (ponumber, "4500608035");
    }
  else if ((strcmp (temp, "1x") == 0))
    {
      safe_strcpy (custcode, "VTI");
      parsevtiorder ();
    }
  else if (strlen (temp) == 7 && temp[(1) - 1] == '0')
    {
      safe_strcpy (custcode, "MIE");
      parsemieorder ();
    }
  else if ((strcmp (temp, "#") == 0))
    {
      safe_strcpy (custcode, "AMS");
      parseamsorder ();
    }
  else if ((strcmp (temp, "Date") == 0))
    {
      safe_strcpy (custcode, "NWL");
      parsenwlorder ();
    }
  else if ((strcmp (temp, "From") == 0))
    {
      safe_strcpy (custcode, "ATM");
      parseatmelorder ();
    }
  else if ((strcmp (temp, "Filtronic") == 0))
    {
      safe_strcpy (custcode, "FCS");
      do
	{
	  read_string (device);
	}
      while (!((strcmp (device, "Device:") == 0)));
      read_string (device);
      do
	{
	  read_string (comments);
	}
      while (!((strcmp (comments, "Comments:") == 0)));
      readline (comments, sizeof (comments));
      imp_toupper (comments);
      do
	{
	  readline (temp, sizeof (temp));
	}
      while (!(strstr (temp, ("Tolerance"))));
    }
  else if ((strcmp (temp, "Order") == 0))
    {
      read_string (temp);
      if ((strcmp (temp, "created") == 0))
	{
	  safe_strcpy (custcode, "ANA");
	  parseanaorder ();
	}
      else if ((strcmp (temp, "No.") == 0))
	{
	  safe_strcpy (custcode, "RMT");
	  parsermtorder ();
	}
      else
	{
	  fatalerror ("Unable to decide the customer from the order form");
	}
    }
  else if ((strcmp (temp, "NATIONAL") == 0))
    {
      safe_strcpy (custcode, "NAT");
      do
	{
	  read_string (device);
	}
      while (!((strcmp (device, "MASK_SET_ID") == 0)));
      read_string (device);
      do
	{
	  read_string (size);
	}
      while (!((strcmp (size, "GLASS_SIZE") == 0)));
      read_string (size);
      do
	{
	  readline (temp, sizeof (temp));
	}
      while (!(strstr (temp, ("DUE_DATE"))));
    }
  else if ((strcmp (temp, "MOS2") == 0) || (strcmp (temp, "MOS3") == 0))
    {
      safe_sprintf (custcode, "PH%c", temp[(4) - 1]);
      do
	{
	  read_string (device);
	}
      while (!((strcmp (device, "MASK_SET_ID") == 0)));
      read_string (device);
      do
	{
	  read_string (size);
	}
      while (!((strcmp (size, "GLASS_SIZE") == 0)));
      read_string (size);
      do
	{
	  read_string (ponumber);
	}
      while (!((strcmp (ponumber, "PO_NUMBER") == 0)));
      read_string (ponumber);
      do
	{
	  readline (temp, sizeof (temp));
	}
      while (!(strstr (temp, ("ADDITIONAL INFO"))));
    }
  else if ((strcmp (temp, "MOS4YOU") == 0))
    {
      safe_strcpy (custcode, "PH4");
      do
	{
	  read_string (device);
	}
      while (!((strcmp (device, "MASK_SET_VERSION") == 0)));
      read_string (device);
      do
	{
	  read_string (size);
	}
      while (!((strcmp (size, "GLASS_SIZE") == 0)));
      read_string (size);
      do
	{
	  read_string (ponumber);
	}
      while (!((strcmp (ponumber, "PO_NUMBER") == 0)));
      read_string (ponumber);
      do
	{
	  readline (temp, sizeof (temp));
	}
      while (!(strstr (temp, ("ADDITIONAL INFO"))));
    }
  else
    if (strstr
	(temp, ("---------------------------------------------------")))
    {
      safe_strcpy (custcode, "TSL");
      parsetslorder ();
    }
  else
    {
      safe_strcpy (custcode, "???");
    }
  if (!
      ((strcmp (custcode, "AMS") == 0) || (strcmp (custcode, "ANA") == 0)
       || (strcmp (custcode, "ATM") == 0) || (strcmp (custcode, "MIE") == 0)
       || (strcmp (custcode, "RMT") == 0) || (strcmp (custcode, "TSL") == 0)
       || (strcmp (custcode, "VTI") == 0) || (strcmp (custcode, "NWL") == 0)))
    {
      readline (temp, sizeof (temp));
      {
	int s;
	for (;;)
	  {
	    if ((strcmp (custcode, "STC") == 0))
	      {
		read_string (device);
		read_string (temp);
		while (nextsymbol () == ' ')
		  skipsymbol ();
	      }
	    else if ((strcmp (custcode, "PH2") == 0)
		     || (strcmp (custcode, "PH3") == 0)
		     || (strcmp (custcode, "PH4") == 0))
	      {
		do
		  {
		    readsymbol (&s);
		  }
		while (!(s == '-'));
	      }
	    do
	      {
		readline (temp, sizeof (temp));
	      }
	    while (!(strcmp (temp, "")));
	    max += 1;
	    safe_strcpy (lines[max], temp);
	  }
      }
    }
  closeinput ();
  safe_strcpy (newfile, "unknown");
  if ((p = strchr (file, '.')) != NULL)
    {
      safe_strncpy (newfile, file, p - file);
    }
  if ((strcmp (custcode, "NAT") == 0))
    safe_strcpy (newfile, device);
  if ((strcmp (custcode, "STC") == 0))
    safe_strcpy (newfile, substring (newfile, 2, strlen (newfile)));	//todo - be careful
  safe_sprintf (newfile, "%s_%s", custcode, newfile);
  if ((strcmp (custcode, "FCS") == 0))
    {
      outputfcsdata ();
    }
  else
    {
      strcat (newfile, ".sop");
      openbinaryoutput (1, newfile);
      selectoutput (1);
      if ((strcmp (custcode, "AMS") == 0))
	{
	  outputamsdata ();
	}
      else if ((strcmp (custcode, "ANA") == 0))
	{
	  outputanadata ();
	}
      else if ((strcmp (custcode, "ATM") == 0))
	{
	  outputatmeldata ();
	}
      else if ((strcmp (custcode, "MIE") == 0))
	{
	  outputmiedata ();
	}
      else if ((strcmp (custcode, "NAT") == 0))
	{
	  outputnatdata ();
	}
      else if ((strcmp (custcode, "NWL") == 0))
	{
	  outputnwldata ();
	}
      else if ((strcmp (custcode, "PH2") == 0)
	       || (strcmp (custcode, "PH3") == 0)
	       || (strcmp (custcode, "PH4") == 0))
	{
	  outputphdata ();
	}
      else if ((strcmp (custcode, "RMT") == 0))
	{
	  outputrmtdata ();
	}
      else if ((strcmp (custcode, "STC") == 0))
	{
	  outputstcdata ();
	}
      else if ((strcmp (custcode, "TSL") == 0))
	{
	  outputtsldata ();
	}
      else if ((strcmp (custcode, "VTI") == 0))
	{
	  outputvtidata ();
	}
      else
	{
	  fatalerror ("Unknown Customer site code %s", custcode);
	}
      closeoutput ();
      reportcreationof (newfile);
    }
  if (qualifierpresent ("SEND"))
    spawncommand ("tosop *.sop");
  if (unix == false)
    {
      strcat (file, ";,");
      strcat (newfile, ";");
    }
  else
    {
      strcat (file, " ");
    }
  if (qualifierpresent ("DELETE"))
    spawncommand ("rm %s%s", file, newfile);
  if (qualifierpresent ("SOPDEL"))
    spawncommand ("rm %s", newfile);
  exit (0);
  return (0);
}
